
// 74hc595 - ms430 
//   12  - P2_0
//   14  - P1_7
//   11  - P1_5
//   10   - +
#include <SPI.h>
#if defined(__MSP430G2452__) || defined(__MSP430G2553__) || defined(__MSP430G2231__) // LaunchPad specific
#include "Energia.h"
#else
#error Board not supported
#endif
#define REG_SELECT  8  // пин, управляющий защёлкой (SS в терминах SPI)

#include <IRremote.h>
int RECV_PIN = P1_3;
IRrecv irrecv(RECV_PIN);

IRsend irsend;
decode_results results;

// x10 marmitek
//const long IR_CODES[12]={0x00,0x08,0x04,0x0C,0x02,0x0A,0x09,0x09,0x06,0x0E,0x01,0x03};
// мама
//const long IR_CODES[12]={0x7F,0xBF,0x3F,0xDF,0x5F,0x9F,0xBF,0xFF,0x1F,0xEF,0x6F,0x6F};
// пульт sony видеоцегнтр
//const long IR_CODES[12]={0x01,0x21,0x41,0x61,0x81,0x09,0x02,0xBF,0x9C,0x9C,0x9C,0x9C};
// для контроллера RGB лент keys24
const long IR_CODES[12]={0xDF,0x9F,0x5F,0xEF,0xAF,0x6F,0x1F,0xBF,0x2F,0x0F,0x37,0x17};
const byte MODES[16][8]={
                      {0x12,1,0x12,2,0x12,3,0x12,1}, // R
                      {0x24,1,0x24,2,0x24,3,0x24,1}, // G
                      {0x48,1,0x48,3,0x48,1,0x48,1}, // B
                      {0x36,1,0x36,2,0x36,3,0x36,1}, // RG
                      {0x6C,1,0x6C,2,0x6C,3,0x6C,1}, // GB
                      {0x5A,1,0x5A,3,0x5A,1,0x5A,1},  // BR
                      {0xFF,1,0xFF,1,0xFF,1,0xFF,1}, // WHITE
                      {0,1,0,2,0,1,0,1}, // BLACK
                      {0x12,5,0x24,5,0x48,5,0x5A,5},  // prg1 r1b1g1y1
                      {0x48,10,0x6C,10,0x48,10,0x6C,10}, // prg2  b3gb1b3gb1
                      {0x48,20,0x22,20,0x12,20,0x12,20},  // prg3
                      {0x12,1,0x12,1,0x12,1,0x12,1}, // prg4
                      {0x48,1,0x22,3,0x12,1,0x12,1},  // prg5
                      {0x12,1,0x12,1,0x12,1,0x12,1}, // prg6
                      {0x48,1,0x22,3,0x12,1,0x12,1},  // prg7
                      {0x12,1,0x12,1,0x12,1,0x12,1} // prg8
                     };
int offset0=0;
int offset1 = 1;           // выбранная программа
int offset2 = 1;           // фрагмент(кадр) прогаммы
int offset3 = 1;           // длительность кадра
int my_channel=1;

void setup()
{
  /* Инициализируем шину SPI. Если используется программная реализация,
   * то вы должны сами настроить пины, по которым будет работать SPI.
   */
  SPI.begin();
  Serial.begin(9600);
  pinMode(REG_SELECT, OUTPUT);
  digitalWrite(REG_SELECT, LOW); // выбор ведомого - нашего регистра
  SPI.transfer(0); // очищаем содержимое регистра
  digitalWrite(REG_SELECT, HIGH);

  irrecv.enableIRIn(); // Start the receiver
  Serial.println("start");
  attachInterrupt(RECV_PIN,ext_ir_code,FALLING);  

  //TwoMsTimer::set(STATE_STEP_INTERVAL, process_step);
  //TwoMsTimer::start();
}


void loop()
 {
 //Serial.print("  ");Serial.print(offset1);
 //Serial.print("  ");Serial.print(offset2);
 //Serial.print("  ");Serial.println(offset3);
 delay(1000);
 process_step();

 }

/*=============================================
 * interrupt handler section
 *=============================================*/

// Interrupt handler that smoothly moves the servo
void process_step(){
  // получение кода отправки
  offset3=offset3-1;
  if(offset3==0)
    {
    offset2=offset2+1;offset2=offset2%4;
    offset3=MODES[offset1-1][offset2*2+1];
    }  /* Записываем значение в сдвиговый регистр */
  digitalWrite(REG_SELECT, LOW);
  SPI.transfer(255-MODES[offset1-1][offset2*2]);
  SPI.transfer(255-MODES[offset1-1][offset2*2]);
  SPI.transfer(255-MODES[offset1-1][offset2*2]);
  //SPI.transfer(255-(B00000001<<offset0));
  delay(10);
  digitalWrite(REG_SELECT, HIGH);
  //Serial.println(255-MODES[offset1-1][offset2*2],BIN);
  offset0++;
  if(offset0==8) offset0=0;
}
// получение кода пульта 
void ext_ir_code()
{
  detachInterrupt(RECV_PIN);
  //Serial.println("in");  
  if (irrecv.decode(&results)) {
    byte ir_kod=lowByte(results.value);
    //byte ir_kod=highByte(results.value);
    Serial.println(ir_kod, HEX);
    // проверка кода
    ir_code_control(ir_kod);
    delay(500);
    irrecv.resume(); // Receive the next value
  }  
  attachInterrupt(RECV_PIN,ext_ir_code,FALLING);
} 
// проверка кода
void ir_code_control(byte kod)
{ //Serial.print("kod= ");;Serial.println(kod1,HEX);
  //return;
  for(int i=0;i<12;i++)
   {
   if(kod==IR_CODES[i])
     {//Serial.print("kodw= ");Serial.println(kod,HEX);
     offset1=i+1;
     offset2=1;offset3=1;
     return;}
   }
}
